From: Emmanuel Arias <eamanu@debian.org>
Date: Tue, 21 Jan 2025 20:24:19 -0300
Subject: Apply workaround to fix httpretty with urllib>=2.3

Apply from https://github.com/PyGithub/PyGithub/pull/3102 to fix
error in httpretty using urllib >= 2.3.
---
 tests/conftest.py | 13 +++++++++++++
 1 file changed, 13 insertions(+)

diff --git a/tests/conftest.py b/tests/conftest.py
index 39d71e1..73869d1 100644
--- a/tests/conftest.py
+++ b/tests/conftest.py
@@ -68,6 +68,19 @@ pytest_plugins = [
 ]
 
 
+getattr = httpretty.core.fakesock.socket.__getattr__
+def patched_getattr(self, name):
+    def shutdown(how: int):
+        pass
+
+    if name == "shutdown" and not httpretty.core.httpretty.allow_net_connect and not self.truesock:
+        return shutdown
+
+    return getattr(self, name)
+
+httpretty.core.fakesock.socket.__getattr__ = patched_getattr
+
+
 def pytest_addoption(parser: Parser) -> None:
     parser.addoption(
         "--integration",
